using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Extended;

namespace H3UtilityToolkit.Misc
{
    public partial class AnalyzedPiece : UserControl
    {
        string mapPath;
        AnalyzePiece ap;

        public AnalyzedPiece(string mapPath, AnalyzePiece ap)
        {
            InitializeComponent();
            this.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right;

            this.mapPath = mapPath;
            this.ap = ap;

            this.BackColor = ap.Colour;
            this.label1.Text = ap.Name;
            this.textBox1.Text = ap.Offset.ToString();
            this.textBox2.Text = ap.Size.ToString();
            this.textBox3.Text = ap.Padding.ToString();
            this.textBox4.Text = ap.Percent.ToString() + "%";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            using (SaveFileDialog s = new SaveFileDialog())
            {
                s.Title = "Save File Dialog";
                string name = Path.GetFileNameWithoutExtension(mapPath);
                if (name.Length > 4) name = name.Remove(4); 
                s.FileName = string.Format("{0}_{1}", name, label1.Text);
                s.Filter = "Halo 3 Section Files (*.h3sec)|*.h3sec|All Files (*.*)|*.*";
                if (s.ShowDialog() == DialogResult.Cancel) return;

                //else
                BitReader br = new BitReader(mapPath, Endian.Little);
                BitWriter bw = new BitWriter(new FileStream(s.FileName, FileMode.Create, 
                    FileAccess.ReadWrite, FileShare.ReadWrite), Endian.Little);

                br.BaseStream.Position = ap.Offset;
                bw.Write(br.ReadBytes(ap.Size + ap.Padding));

                bw.Close();
                br.Close();
            }
        }
    }
}
