//--------------------------------------------------------------------------------------
// File: ExTextBox.cs
//
// Extended TextBox
//
// Copyright (c) Alex Lynch (alias. Prey). All rights reserved.
//--------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace System.Extended
{
    /// <summary>
    /// Represents a Windows (extended) text box control.
    /// </summary>
    [ComVisible(true)]
    [Designer("System.Windows.Forms.Design.TextBoxDesigner, System.Design, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a")]
    [ClassInterface(ClassInterfaceType.AutoDispatch)]
    public class ExTextBox : TextBox
    {
        /// <summary>
        /// Initializes a new instance of the System.Extended.TextBox class.
        /// </summary>
        public ExTextBox()
            : base()
        {
        }

        /// <summary>
        /// Raises the System.Windows.Forms.Control.PreviewKeyDown event.
        /// </summary>
        /// <param name="e">A System.Windows.Forms.PreviewKeyDownEventArgs that contains the event data. </param>
        protected override void OnPreviewKeyDown(PreviewKeyDownEventArgs e)
        {
            if (e.Control && e.KeyCode == Keys.A)
            {
                this.SelectAll();
            }
            else
            {
                base.OnPreviewKeyDown(e);
            }
        }
    }
}